/*
 * Dialog with List - Account Details
 * by PhilFlash - http://philflash.inway.fr
 *
 */
 
import mx.controls.Button;
import mx.controls.Label;
import mx.controls.List;
import mx.controls.TextInput;

import mx.data.components.DataSet;
import mx.data.components.XMLConnector;

import mx.styles.CSSStyleDeclaration;

import mx.containers.Window;

 
class AccountForm extends mx.screens.Form {
 
	public var country_ds:DataSet = null;
 	public var country_con:XMLConnector = null;
 	
 	public var countryButton:Button = null;
 	
 	public var label_ti:TextInput;
	public var firstname_ti:TextInput;	
	public var lastname_ti:TextInput;
	public var country_ti:TextInput; 	
 	
 	// Constructor
 	public function AccountForm() {}
 	
 
 	public function init():Void {
 		super.init();
 		//addEventListener("load", this);
 	}
 	
 	public function onLoad():Void {
 
 		// -- Button --
 		countryButton.addEventListener("click", this);
 		
 		// TabIndex
 		firstname_ti.tabIndex = 1;
 		lastname_ti.tabIndex = 2;
  		countryButton.tabIndex = 3;
  		
		var styleObj:CSSStyleDeclaration= new mx.styles.CSSStyleDeclaration();
		styleObj.styleName = "myStyle";
		styleObj.fontFamily = "Verdana";
		styleObj.fontSize = 12;
		styleObj.fontWeight = "bold";
		//styleObj.color = 0x000000;
		_global.styles["myStyle"] = styleObj;
		
 		// -- TextInput --
		// Title 
		label_ti.editable = false;
 		label_ti.setStyle("styleName", "myStyle");
		label_ti.setStyle("backgroundColor", 0xE8F0F1);

		label_ti.setStyle("buttonColor", 0xE8F0F1);
		label_ti.setStyle("highlightColor", 0xE8F0F1);
		// cote
		label_ti.setStyle("shadowCapColor", 0xE8F0F1);
		label_ti.setStyle("borderCapColor", 0xE8F0F1);
		// bas
		label_ti.setStyle("shadowColor", 0xE8F0F1);
		label_ti.setStyle("borderColor", 0xC3C8CD); 		
 		
 		// -- TextInput --
		// first name
		firstname_ti.setStyle("backgroundColor", 0xF7F7F7);
		firstname_ti.setStyle("buttonColor", 0xFFFFFF);
		firstname_ti.setStyle("highlightColor", 0x999999);
		// cote
		firstname_ti.setStyle("shadowCapColor", 0xAAB3B3);
		firstname_ti.setStyle("borderCapColor", 0xFFFFFF);
		// bas
		firstname_ti.setStyle("shadowColor", 0xD5DDDD);
		firstname_ti.setStyle("borderColor", 0xFFFFFF); 	
		
		// last name
		lastname_ti.setStyle("backgroundColor", 0xF7F7F7);
		lastname_ti.setStyle("buttonColor", 0xFFFFFF);
		lastname_ti.setStyle("highlightColor", 0x999999);
		// cote
		lastname_ti.setStyle("shadowCapColor", 0xAAB3B3);
		lastname_ti.setStyle("borderCapColor", 0xFFFFFF);
		// bas
		lastname_ti.setStyle("shadowColor", 0xD5DDDD);
		lastname_ti.setStyle("borderColor", 0xFFFFFF); 
		
 		
 		// country
 		country_ti.editable = false;
		country_ti.setStyle("backgroundColor", 0xF7F7F7);
		// haut
		country_ti.setStyle("buttonColor", 0xEEEEEE);
		country_ti.setStyle("highlightColor", 0xEEEEEE);
		// cote
		country_ti.setStyle("shadowCapColor", 0xEEEEEE);
		country_ti.setStyle("borderCapColor", 0xEEEEEE);
		// bas
		country_ti.setStyle("shadowColor", 0xEEEEEE);
		country_ti.setStyle("borderColor", 0xEEEEEE); 		
 		
 		// -- XMLConnector --
 		country_con.trigger();
 	}
 	
 	// ----- Button Action -----
 	public function click(eventObj:Object):Void {
 		var target:Object = eventObj.target;
 		if (target == countryButton) {
 			countryAction(eventObj);
 		} 
	}

	// -----  -----
	public function countryAction(evt:Object):Void {
		var target = evt.target;
		
		var countryDataSet:DataSet = country_ds; 
		var currentValue = country_ti.text;
		
		var wndAsker;
		wndAsker = mx.managers.PopUpManager.createPopUp(_root, mx.containers.Window, true, 
				{title:"Choose a country", contentPath:"countryDialog", closeButton:false});
		
		wndAsker.addEventListener("complete", function(evt:Object) { evt.target.content.initAsker(countryDataSet, currentValue); } );

		// No Drag
		//wndAsker.startDragging = function() {};
		
		var myWindowListener = new Object();
		myWindowListener.owner = this;
		myWindowListener.click = function(eventObj:Object) {
			var target = eventObj.target;
			var detail = eventObj.detail;
			target.deletePopUp();
			if (detail == 1) {
				var index = eventObj.selectedIndex;
				var newValue = eventObj.selectedItem.label;
				
				var oldValue = this.owner.country_ti.text;
				if (newValue != oldValue) {
					this.owner.country_ti.text = newValue;
				}
			}
		};
		wndAsker.addEventListener("click", myWindowListener);
		
		wndAsker.setSize(250, 310);
		
		// si on veut le dialogue centr au dessus du bouton
		//setLocationRelativeTo(wndAsker, target);
		setLocationRelativeTo(wndAsker, null);
	}	 	
 	
 	// -----  -----
 	static function setLocationRelativeTo(mc:MovieClip, owner:Object) {
 		var x0:Number = 0;
 		var y0:Number = 0;
 		if (owner != undefined && owner instanceof MovieClip) {
 			x0 = owner._x+(owner._width/2);
 			y0 = owner._y+(owner._height/2);	
 			var x:Number = x0 - mc._width/2;
 			var y:Number = y0 - mc._height/2;
 			if (x < 0) {
 				x = 0;
 			}
 			if (y < 0) {
 				y = 0;
 			}
 			if (x + mc._width > Stage.width) {
 				x = Stage.width - mc._width;
 			}
 			if (y + mc._height > Stage.height) {
 				y = Stage.height - mc.height;
 			}
 
 			mc.move(x,y);		
 		} else {
 			mc.move((Stage.width-mc._width)/2, (Stage.height-mc._height)/2);	
 		}
 	}
 	
}